'*************************************************************************************
'*************************************************************************************
'**                                                                                 **
'**  Tinyplayer - TibV2 example                                                     **
'**  written by Tammo 'kb' Hinrichs 2000-2008                                       **
'**  This file is in the public domain                                              **
'**  "Patient Zero" is (C) Melwyn+LB 2005, do not redistribute                      **
'**                                                                                 **
'*************************************************************************************
'*************************************************************************************
'
' ===========================================================================
' Freebasic compatible library and wrapper by rbz - 14 Feb 2009
' ===========================================================================

#include "windows.bi"
#include "libv215.bi"

'Include song
#include "Songs\pzero_new.bas" 

    dim l as single
    dim r as single
    dim ll as integer
    dim rr as integer
    dim i as integer
    dim j as integer
    
    Cls
    Locate 1, 1
 
    Print "-------------------------------------------------------------"
    Print "Farbrausch Tiny Music Player v0.dontcare TWO"
    Print "Code and Synthesizer (C) 2000-2008 kb/Farbrausch"
    Print ""
    Print "Freebasic compatible library and wrapper by rbz - 14 Feb 2009"
    Print "-------------------------------------------------------------"

	' init synthesizer and player with the tune and the current window
    If libV215_Init(@theTune(0), 44100, 1000, GetForegroundWindow())  =  0  Then
        Print "Init Error..."
        Sleep 2000
        End 1
    End If

  	' start playing
	libV215_Play(0) 
    
    ' Set volume
    libV215_SetVolume(1.0)
    
    ' set vu mode = 0 for peak meters
    libV215_SetVUMode(0)
      
    Print "Now Playing: 'Patient Zero' by Melwyn & Little Bitchard"
    Print "Press a key to exit"

    dim anim(4) as string
    anim(0) = "|"
    anim(1) = "/"
    anim(2) = "-"
    anim(3) = "\"
  
    While Inkey$ = ""
        
 		' draw rotating stuff and make sure we don't use up 100% cpu
		locate 9,1
		print anim((libV215_GetCurSmp()/20000.0) and 3)
        
        for i = 0 to 13 'channel to retrieve (0..15)
            libV215_GetChannelVU(i,@l,@r)
            ll = cast(integer,l*15.0)
            rr = cast(integer,r*15.0)
            
            for j = 0 to ll
                locate 10,1: Print "Left Channel:"
                locate 11+i,1+j: print "#                            "
            next
        
            for j = 0 to rr
                locate 10,35: Print "Right Channel:"
                locate 11+i,35+j: print "#                           "
            next
            
        next
              
		Sleep(10) 
      
    Wend
   
	' stop and deinit the player
	libV215_Stop(0)
	libV215_Close() 

    Print "Music Stopped"
    Sleep 2000
    
	' ... and we're done.
	ExitProcess(0)
    
    End
    
    

 