'  ===========================================================================
'
'  libv2 1.5 - Farbrausch Consumer Consulting's famous tiny synthesizer 
'  and music player for YOU.

'  (C) Tammo 'kb' Hinrichs 2000-2008
'  Placed under the Artistic License 2.0, see LICENSE.txt for details
'
'  ===========================================================================
'
'  ===========================================================================
'   Freebasic compatible library and wrapper by rbz - 14 Feb 2009
'  ===========================================================================

#ifndef LIBV215_H_
#define LIBV215_H_

#include "windows.bi"
#include "win/mmsystem.bi"

#if __FB_VERSION__ < "0.17" 
    '$inclib: "dsound"
    '$inclib: "v215"
#else
    #inclib "dsound"
    #inclib "v215" 
#endif

'' ===========================================================================
''                          farbrausch V215 API                                
'' ===========================================================================
	' init sound system
	' music: pointer to V2M file
    ' SampleRate: song Sample Rate (default=44100)
    ' Tickspersec: song ticks per second (default=1000)
    ' hWnd: window handle
    Declare Function libV215_Init cdecl Alias "libV215_Init"(byval music as any ptr, byval SampleRate as integer, byval Tickspersec as integer, byval hWnd as HWND) as integer

	' start playing (from song start)
    'a_time   : time offset from song start in msecs
    Declare Sub libV215_Play cdecl Alias "libV215_Play"(byval a_time as integer)

	' stop playing
    ' a_fadetime : optional fade out time in msecs
    Declare Sub libV215_Stop cdecl Alias "libV215_Stop"(byval a_fadetime as integer)
    
	' close sound system
    Declare Sub libV215_Close cdecl Alias "libV215_Close"()    

    ' returns if song is currently playing
    Declare Function libV215_IsPlaying cdecl Alias "libV215_IsPlaying"  () as integer

    ' sets operation mode of VU meters
    ' mode : 0 for peak meters, 1 for RMS meters
    Declare Sub libV215_SetVUMode cdecl Alias "libV215_SetVUMode"(byval mode as integer)

    ' retrieves VU meter data for a channel
    ' ch   : channel to retrieve (0..15)
    ' l    : pointer to float variable where left VU is stored
    ' r    : pointer to float variable where right VU is stored
    Declare Sub libV215_GetChannelVU cdecl Alias "libV215_GetChannelVU"(byval ch as integer, byval l as single ptr, byval r as single ptr)

    ' gets sample-exact and latency compensated current play position
    Declare Function libV215_GetCurSmp cdecl Alias "libV215_GetCurSmp"  () as long
    
    ' sets player volume (default is 1.0)
    Declare Sub libV215_SetVolume cdecl Alias "libV215_SetVolume"(byval volume as single)

    ' forces rendering thread to update. On single-core CPUs it's a good idea to
    ' call this once per frame (improves A/V sync and reduces any stuttering), 
    ' with more than one CPU it's pretty much useless.
    Declare Sub libV215_Tick cdecl Alias "libV215_Tick"()
    

